package cn.iocoder.yudao.module.system.service.biz;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;
import cn.iocoder.yudao.module.system.controller.admin.biz.vo.diapersgetrecord.ElderlyDiapersGetRecordPageReqVO;
import cn.iocoder.yudao.module.system.controller.admin.biz.vo.diapersgetrecord.ElderlyDiapersGetRecordRespVO;
import cn.iocoder.yudao.module.system.controller.admin.biz.vo.diapersgetrecord.ElderlyDiapersGetRecordSaveReqVO;
import cn.iocoder.yudao.module.system.dal.dataobject.biz.ElderlyDiapersGetRecordDO;
import cn.iocoder.yudao.module.system.dal.mysql.biz.ElderlyDiapersGetRecordMapper;
import org.springframework.stereotype.Service;
import org.springframework.validation.annotation.Validated;

import javax.annotation.Resource;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.system.enums.ErrorCodeConstants.COMMON_NOT_FOUND;

@Service
@Validated
public class ElderlyDiapersGetRecordServiceImpl implements ElderlyDiapersGetRecordService {

    @Resource
    private ElderlyDiapersGetRecordMapper elderlyDiapersGetRecordMapper;

    @Override
    public Long create(ElderlyDiapersGetRecordSaveReqVO createReqVO) {
        ElderlyDiapersGetRecordDO record = BeanUtils.toBean(createReqVO, ElderlyDiapersGetRecordDO.class);
        elderlyDiapersGetRecordMapper.insert(record);
        return record.getId();
    }

    @Override
    public void update(ElderlyDiapersGetRecordSaveReqVO updateReqVO) {
        validateExists(updateReqVO.getId());
        ElderlyDiapersGetRecordDO updateObj = BeanUtils.toBean(updateReqVO, ElderlyDiapersGetRecordDO.class);
        elderlyDiapersGetRecordMapper.updateById(updateObj);
    }

    @Override
    public void delete(Long id) {
        validateExists(id);
        elderlyDiapersGetRecordMapper.deleteById(id);
    }

    @Override
    public ElderlyDiapersGetRecordRespVO get(Long id) {
        ElderlyDiapersGetRecordDO record = elderlyDiapersGetRecordMapper.selectById(id);
        if (record == null) {
            throw exception(COMMON_NOT_FOUND);
        }
        return BeanUtils.toBean(record, ElderlyDiapersGetRecordRespVO.class);
    }

    @Override
    public PageResult<ElderlyDiapersGetRecordRespVO> getPage(ElderlyDiapersGetRecordPageReqVO pageReqVO) {
        return elderlyDiapersGetRecordMapper.selectPageWithBuildInfo(pageReqVO);
    }

    private void validateExists(Long id) {
        if (id == null || elderlyDiapersGetRecordMapper.selectById(id) == null) {
            throw exception(COMMON_NOT_FOUND);
        }
    }
}
